public:
	// enkeyDEV: ICS
	void	MOD_ProcessFileIncStatus(CSafeMemFile* data,uint32 size, bool readHash = false, CClientFileStatus* fileStatus = NULL);
	uint32	GetIncompletePartVersion()	{return m_incompletepartVer;}
	bool	MOD_IsPendingListEmpty()      {return m_PendingBlocks_list.IsEmpty();}
	// <--- enkeyDEV: ICS
protected:
	// MOD BEGIN netfinity:
	friend	class CClientDetailDialog;
	friend	class CUploadQueue;
	friend	class CPartFile;
public:
	uint32	GetScore(bool sysvalue, bool isdownloading = false, bool onlybasevalue = false, bool paybackslot = false) const;
	bool	MOD_IsDifferentPartBlock();
	bool	MOD_SupportIntelligentChunkSelection() const { return (m_incompletepartVer > 0); }
	uint32 MOD_GetMaxTransfer(bool checkLastTransfer = false);
	bool	MOD_IsPartialSource();
	uint32 MOD_GetEstimatedDownloadRate(void) const;
	uint32 MOD_GetEstimatedUploadRate(void) const;
private:
	void	MOD_Init_Post();
	void	MOD_Destruct_Post();
	void	MOD_ClearHelloProperties_Post();
	void	MOD_SendMuleInfoPacket_AddTags(CList<CTag*> *etTags);
	void	MOD_ProcessMuleInfoPacket_Pre();
	void	MOD_ProcessMuleInfoPacket_Post();
	void	MOD_SendHelloTypePacket_AddTags(CList<CTag*> *ctTags);
	void	MOD_ResetFileStatusInfo_Pre();

	// Anti Leech
public:
	bool					m_bIsModifiedClient;	//!< Client appears not to be an official eMule client
	bool					m_bHasClonedModString;	//!< Client has copied our Mod string
	// Download slot management
private:
	uint32					m_lastBlockOffset;
	uint32					m_dwNoNeededPartsPending;
	// Upload slot management
	uint32					m_dwUploadTimeBonus;
	uint32					m_dwRemovePending;
	// Statistics
	uint64					m_qwCumulativeDownloadBytes;
	uint64					m_qwCumulativeUploadBytes;
	uint32					m_dwCumulativeDownloadTime;
	uint32					m_dwCumulativeUploadTime;
	// Workarounds
public:
	// MOD END netfinity
	// enkeyDEV: ICS
private:
	uint32	m_incompletepartVer;
	// <--- enkeyDEV: ICS
	// MOD BEGIN netfinity: Anti HideOS
public:	// It's a Mod, lacy coding is what you should expect
	// MOD END netfinity
	uchar						m_LastFailedFileNameReqHash[16];
	CClientFileStatusList		m_FileStatusList;
	CSafePtr<CClientFileStatus>	m_pUpFileStatus;
	CSafePtr<CClientFileStatus>	m_pDownFileStatus;

	const CString	GetClientModVer() const
	{
		if(m_strModVersion == MOD_VERSION && 
			(!IsEmuleClient() || !m_incompletepartVer ||
			 m_nClientVersion != ((VERSION_MJR << 17) | (VERSION_MIN << 10) |	(VERSION_UPDATE	<< 7))
			)
		   )
			return _T("!!! Mod string thief !!!");
		if(m_strModVersion.IsEmpty() && IsEmuleClient() && m_bIsModifiedClient)
			return _T("!!! Missing Mod string !!!");
		return m_strModVersion;
	}
